
from ext import cdataset
import Numeric

def arrayFromDoubleArray(doubleArray, length) :

    array = Numeric.zeros(length, Numeric.Float)
    for i in range(length) :
        array[i] = doubleArray[i]
    return array


def doubleArray(a) :

    array = cdataset.doubleArray(len(a))
    for i in range(len(a)) :
        array[i] = a[i]

    return array

def intArray(a) :

    array = cdataset.intArray(len(a))
    for i in range(len(a)) :
        array[i] = a[i]

    return array

def doubleVector(v = None) :

    if v is None : return cdataset.DoubleVector()
    vector = cdataset.DoubleVector(len(v))
    for i in range(len(v)) :
        vector[i] = v[i]

    return vector

def intVector(v = None) :

    if v is None : return cdataset.IntVector()
    vector = cdataset.IntVector(len(v))
    for i in range(len(v)) :
        vector[i] = v[i]

    return vector

def longVector(v = None) :

    if v is None : return cdataset.LongVector()
    vector = cdataset.LongVector(len(v))
    for i in range(len(v)) :
        vector[i] = v[i]

    return vector

def datasetVector(v) :

    if v is None : return cdataset.DataSetPtrVector()
    vector = cdataset.DataSetPtrVector(len(v))
    for i in range(len(v)) :
        vector[i] = v[i]

    return vector

def intVector2list(v) :

    vPtr = cdataset.IntVectorPtr(v)
    return [vPtr[i] for i in range(len(vPtr))]

def doubleVector2list(v) :

    vPtr = cdataset.DoubleVectorPtr(v)
    return [vPtr[i] for i in range(len(vPtr))]

def dict2vectors(a) :

    keys = cdataset.LongVector(len(a))
    #keys = cdataset.IntVector(len(a))
    values = cdataset.DoubleVector(len(a))
    keyList = a.keys()
    keyList.sort()
    for i in range(len(keyList)) :
        keys[i] = keyList[i]
        values[i] = a[keys[i]]

    return keys,values
        

doubleArray_frompointer = cdataset.doubleArray_frompointer
