# $Revision: 1.11 $
import sys
import Mass
import cPickle
import random
import MatchCollection
import random
import re


# creates and returns the train and test psm Fnames, given a psmFname
# ratio is that of train to the whole
def splitPsm(inputPsmColl, ratio=2.0, idx=0):
  trainPeptides = {}
  testPeptides = {}
  testPsm  = MatchCollection.PsmMatchCollection()
  trainPsm = MatchCollection.PsmMatchCollection()
  #psmColl["matches"].sort(lambda x,y: cmp(float(x.spectrum["retention time"]), \
  #  float(y.spectrum["retention time"])))

  inputPsmColl["matches"].sort(lambda x,y: cmp(random.random(), random.random()))

  trainCount = 0
  for psm in inputPsmColl["matches"]:
    trainCount += 1
    if trainPeptides.has_key(psm.peptide): 
      trainPsm["matches"].append(psm)
    elif testPeptides.has_key(psm.peptide): 
      testPsm["matches"].append(psm)
    elif trainCount <= (len(inputPsmColl["matches"]) * ratio):
      trainPsm["matches"].append(psm)
      trainPeptides[psm.peptide] = 1
    else:
      testPsm["matches"].append(psm)
      testPeptides[psm.peptide] = 1

  return trainPsm, testPsm

#------------------------------------------------------
def uniquePeptide(inputPsmColl=None, maxDupPeptide=1, minPeptide=1):

  seenPeptides = {}

  # organize the matches by peptide
  outputPsmColl = MatchCollection.PsmMatchCollection()
  for match in inputPsmColl["matches"]:
    if seenPeptides.has_key(match.peptide): 
      seenPeptides[match.peptide].append( match )
    else: 
      seenPeptides[match.peptide] = [ match ]
 
  # take the best xcorr for each peptide if we have more than minPeptide
  for peptide in seenPeptides.keys():
    if len(seenPeptides[peptide]) < minPeptide: 
      continue
    seenPeptides[peptide].sort(lambda x,y: cmp(float(y["xcorr"]), \
      float(x["xcorr"])))
    for match in seenPeptides[peptide][0:maxDupPeptide]:
      outputPsmColl["matches"].append(match)

  return outputPsmColl

#-------------------------------------------------------------------------------
def removeRealRandoms(normalPsmColl, randomPsmColl):

  realPeptides = {}
  for match in normalPsmColl["matches"]: 
    peptide = match.peptide
    re.sub(peptide, 'I', 'L')
    realPeptides[peptide] = 1

  outputPsmColl = MatchCollection.PsmMatchCollection()
  for match in randomPsmColl["matches"]:
    peptide = match.peptide
    re.sub(peptide, 'I', 'L')
    if realPeptides.has_key(peptide): continue
    outputPsmColl["matches"].append(match)
  
  return outputPsmColl

#-------------------------------------------------------------------------------
def filterPsmFDR(normalPsmColl, randomPsmColl, fdr=0.01, score="xcorr", \
    maximumLength=100000, minimumLength=0):

  allMatches = []
  # print >>sys.stderr, "Length normal %i" % len(normalPsmColl["matches"])
  # print >>sys.stderr, "Length random %i" % len(randomPsmColl["matches"])
  for match in normalPsmColl["matches"]: allMatches.append( (match, True) )
  for match in randomPsmColl["matches"]: allMatches.append( (match, False) )

  allMatches.sort( lambda x,y: \
      cmp( float(y[0]["xcorr"]), float(x[0]["xcorr"]) ) )

  outputPsmColl = MatchCollection.PsmMatchCollection()
  excessPsmColl = MatchCollection.PsmMatchCollection()
  p = fp = 0.0
  exceededFDR = False
  for match in allMatches:
    if match[1] == True: p += 1
    else: fp += 1
    if p == 0.0: break
    if (fp/p) > fdr: exceededFDR = True
    if (
         match[1] == True

         and

         (exceededFDR == False
           or 
          len(outputPsmColl["matches"]) < minimumLength)

         and 

         len(outputPsmColl["matches"]) < maximumLength
       ):
          outputPsmColl["matches"].append(match[0])
    else: 
      excessPsmColl["matches"].append(match[0])
  
  print >>sys.stderr, "%i psms after filtering for FDR" \
      % len(outputPsmColl["matches"])
  return outputPsmColl, excessPsmColl

#-------------------------------------------------------------------------------
def filterPsm(inputPsmColl, xcorr=-10.0, deltCN=-10.0, charge=None, \
    ionFraction=-10.0, tryptic=True, rt=0):

  outputPsmColl = MatchCollection.PsmMatchCollection()
  matches = filter(lambda x: float(x["xcorr"])  > xcorr \
      and float(x["deltCN"]) > deltCN,  inputPsmColl["matches"])

  if charge != None:
    matches = filter(lambda x: int(x["charge"]) == charge, matches)
  
  outputPsmColl["matches"]  = matches
  if rt != 0:
    newMatches = []
    print >>sys.stderr, "Before rt filtering %i" % len(matches)
    for match in outputPsmColl["matches"]:
      try:
        if float(match.spectrum["retention time"]) > float(rt):
          newMatches.append(match)
      except:
        continue
    print >>sys.stderr, "After rt filtering %i" % len(newMatches)
    outputPsmColl["matches"]  = newMatches

  if tryptic == True:
    outputPsmColl["matches"] = filter(lambda x: x["peptide"][-1] in 'KR', \
      outputPsmColl["matches"])

  outputPsmColl["matches"] = filter(lambda x: float(x["matched ions"]) \
    / float(x["expected ions"]) > ionFraction, outputPsmColl["matches"])

  print >>sys.stderr, "%i psms after filtering" % len(outputPsmColl["matches"])

  outputPsmColl["matches"].sort(lambda x,y: cmp(random.random(), random.random()))

  return outputPsmColl
